#include <Stepper.h>

/*------------------------------
 initialization for
 input (memory)
 ------------------------------*/

int pin0 = 3; //rotery0
int pin1 = 4; //rotery0
int pin2 = 11; //rotery1
int pin3 = 12; //rotery1

int num = 0; //rotery0
int preNum = 0; //rotery0
int num1 = 0; //rotery1
int preNum1 = 0; //rotery1

int val = 0; //rotery0
int val1 = 0; //rotery1

int mem[50]; // memory
const int sizeMem = sizeof mem / sizeof mem[0]; // size of mem

int i = 0;


/*------------------------------
 initialization for
 output (stepper moter)
 ------------------------------*/

// change this to the number of steps on your motor
#define STEPS 480 // 1kaiten step su

int pinStpr0 = 8; // the pin attatched to the stepper motor
int pinStpr1 = 9; // the pin attatched to the stepper motor

int pinStpr2 = 6;
int pinStpr3 = 7;

int iRpm = 5; // the value of RPMs of the motor

int stpNum = 20; // how many steps the stepper moves at once

// create an instance of the stepper class, specifying
// the number of steps of the motor and the pins it's
// attached to
Stepper stepper(STEPS, pinStpr0, pinStpr1);
Stepper stepper1(STEPS, pinStpr2, pinStpr3);




/*------------------------------
 setup
 ------------------------------*/

void setup(){
  Serial.begin(9600);
  pinMode(pin0, INPUT);
  pinMode(pin1, INPUT);
  pinMode(pin2, INPUT);
  pinMode(pin3, INPUT);

  // set the speed of the motor to iRpm RPMs
  stepper.setSpeed(iRpm);
  stepper1.setSpeed(iRpm);
}




/*------------------------------
 main program
 ------------------------------*/

void loop(){
  /*------------------------
  input from rotery encoder0
  ------------------------*/
  if(digitalRead(pin0) == HIGH && digitalRead(pin1) == LOW){
    preNum = num;
    num = 1;
  }
  else if(digitalRead(pin0) == HIGH && digitalRead(pin1) == HIGH){
    preNum = num;
    num = 2;
  }
  else if(digitalRead(pin0) == LOW && digitalRead(pin1) == HIGH){
    preNum = num;
    num = 3;
  }
  else if(digitalRead(pin0) == LOW && digitalRead(pin1) == LOW){
    preNum = num;
    num = 4;
  }

  if(preNum == num + 1){
    val++;
  }
  if(preNum == num - 1){
    val--;
  }

  if(val == 3){
    Serial.println('R');
    mem[i] = 1;
    i++;
    val = 0;
  }
  if(val == -3){
    Serial.println('L');
    mem[i] = 2;
    i++;
    val = 0;
  }
  if(i == sizeMem){
    for(int j=0; j<sizeMem-1; j++){
      mem[j] = mem[j+1];
    }
    mem[sizeMem-1] = 0;
    i = sizeMem-1;
  }
  
  /*------------------------
  input from rotery encoder1
  ------------------------*/
  if(digitalRead(pin2) == HIGH && digitalRead(pin3) == LOW){
    preNum1 = num1;
    num1 = 1;
  }
  else if(digitalRead(pin2) == HIGH && digitalRead(pin3) == HIGH){
    preNum1 = num1;
    num1 = 2;
  }
  else if(digitalRead(pin2) == LOW && digitalRead(pin3) == HIGH){
    preNum1 = num1;
    num1 = 3;
  }
  else if(digitalRead(pin2) == LOW && digitalRead(pin3) == LOW){
    preNum1 = num1;
    num1 = 4;
  }

  if(preNum1 == num1 + 1){
    val1++;
  }
  if(preNum1 == num1 - 1){
    val1--;
  }

  if(val1 == 3){
    Serial.println('U');
    mem[i] = 3;
    i++;
    val1 = 0;
  }
  if(val1 == -3){
    Serial.println('D');
    mem[i] = 4;
    i++;
    val1 = 0;
  }
  
  if(i == sizeMem){
    for(int j=0; j<sizeMem-1; j++){
      mem[j] = mem[j+1];
    }
    mem[sizeMem-1] = 0;
    i = sizeMem-1;
  }
  
  if(Serial.available()>0){
    switch (Serial.read()) { //read swith sentence data
    /*---------------
    output to stepper
    ---------------*/
    case 'a':
      Serial.print("mem:");
      for(int j=0; j<sizeMem-1; j++){
        Serial.print(mem[j]);
      }
      Serial.println(mem[sizeMem-1]);
      break;
    
    case 'r':
      for(int j=0; j<i; j++){
        if(mem[j]==1){
          stepper.step(stpNum);
        }
        else if(mem[j]==2){
          stepper.step(stpNum*(-1));
        }
        else if(mem[j]==3){
          stepper1.step(stpNum);
        }
        else if(mem[j]==4){
          stepper1.step(stpNum*(-1));
        }
      }
      break;
      
    case 'b':
      for(int j=i; j>=0; j--){
        if(mem[j]==1){
          stepper.step(stpNum*(-1));
        }
        else if(mem[j]==2){
          stepper.step(stpNum);
        }
        else if(mem[j]==3){
          stepper1.step(stpNum*(-1));
        }
        else if(mem[j]==4){
          stepper1.step(stpNum);
        }
      }
      break;
    
    case 'd':
      for(int j=0; j<i; j++){
        mem[j] = 0;
      }
      i = 0;
      break;
    }
  }
}
